Subject: Re: bug#44611: Prefix arg for xref-goto-xref

From: Juri Linkov <[email-masked]>
Date: Tue, 16 Mar 2021 20:15:22 +0200

> I want to propose another alternative: to implement C-u RET
> not only for compilation-mode, but also for e.g. occur-mode,
> maybe current-prefix-arg could be handled in 'next-error-found'
> by adding to the end:
>
>   (when (and current-prefix-arg from-buffer (not (eq from-buffer to-buffer)))
>     (let ((window (get-buffer-window from-buffer)))
>       (with-selected-window window
>         (quit-restore-window window))))

Actually, 'window' should be checked with window-live-p,
because 'xref-goto-xref' could already quit the window.

> So since 'C-u M-g n' is already taken, an alternative is 'C-0 M-g n'.
> If 'C-0' makes no sense for 'C-0 M-g n', it could be used to close the window.
> Or maybe 'C-0 M-g n' still makes sense, e.g. to redisplay the current location?

I withdraw this proposal because it's easy to do this in the init file:

  (defun next-error-quit-window ()
    (when (and (eq current-prefix-arg 0)
               (not (eq next-error-last-buffer (current-buffer))))
      (let ((window (get-buffer-window next-error-last-buffer)))
        (when (window-live-p window)
          (with-selected-window window
            (quit-restore-window window))))))

  (add-hook 'next-error-hook 'next-error-quit-window)

> BTW, here are the commands that work like TAB in grep-mode.
> I propose to install this patch, so at least users could bind them
> in own init files:

Now pushed to master.